package RPM::Source::Abstract::ExportCommandLineOptionContainer;

use strict;
use warnings;

use RPM::Source::Abstract::ExportCommandLineOption;

our @ISA=qw/RPM::Source::Abstract::ExportCommandLineOption/;
our $VERSION=0.002;

my %class_once;

sub new {
    my $class = shift;
    my $self = {
	@_
    };
    bless $self, $class;
    return $self;
}

sub _check_called {
    my ($self,$method)=@_;
    if (ref ($self)) {
	return 1 if $self->{$method};
	$self->{$method}=1;
	return 0;
    } else {
	return 1 if $class_once{$self.'::'.$method};
	$class_once{$self.'::'.$method}=1;
	return 0;
    }
}

sub longopt_usage {
    my ($self)=@_;
    return if &_check_called($self,'__longopt_usage');
    map {$_->longopt_usage} @{$self->_container_arrayref};
}

sub get_longopt {
    my ($self)=@_;
    return if &_check_called($self,'__get_longopt');
    return map {$_->get_longopt} @{$self->_container_arrayref};
}

sub process_options {
    my ($self)=@_;
    return if &_check_called($self,'__process_options');
    map {$_->process_options} @{$self->_container_arrayref};
}

1;
