package RPM::Source::Shared::Resource::Debug;

use strict;
use warnings;
use Carp;
no strict "refs";

use RPM::Source::Shared::Resource;
use RPM::Source::Shared::ResourceContainer;
our @ISA=qw/RPM::Source::Shared::Resource/;

unshift @RPM::Source::Shared::ResourceContainer::RESOURCE_CLASSES, __PACKAGE__;

my (@opt_def, @opt_load);

sub longopt_usage {
    print "
  Debug options:
	--SET '<name>=<value>' set the value of global variable
	--LOAD '<name>' == require '<name>' (load module)
";
}

our @LONGOPT=(
    'SETVAR=s'	=> \@opt_def,
    'LOADMOD=s'	=> \@opt_load,
);

sub process_options {
    my ($self)=@_;
    for my $mod (@opt_load) {
	eval "require $mod";
	warn "require module $mod failed: $@\n" if $@;
    }
    for my $expr (@opt_def) {
	my $var=$expr;
	my $val=1;
	if ($var =~ /^([^\s=]+)[\s=]+(.*)$/) {
	    $var=$1;
	    $val=$2;
	}
	eval {
	    ${$var}=$val;
	};
	warn "setting variable $expr failed: $@\n" if $@;
    }
}

1;
