package RPM::Source::Tools::HackOverSourceAnalyzer;

use strict;
use warnings;
our $verbose=0;

my $select_multiple_dependency_db = {
	    '/usr/bin/latex' => 'texlive-latex-base',
	    '/usr/bin/pslatex' => 'texlive-latex-base',
	    '/usr/bin/java' => 'java-devel-default',
	    '/usr/bin/javac' => 'java-devel-default',
	    '/usr/bin/javadoc' => 'java-devel-default',
	    '/usr/bin/javah' => 'java-devel-default',
	    '/usr/bin/javap' => 'java-devel-default',
	    '/usr/bin/jar' => 'java-devel-default',
	    '/usr/bin/flex' => 'flex',
	    '/usr/bin/flex++' => 'flex',
	    '/usr/bin/rsync' => 'rsync',
	    '/usr/bin/texi2html' => 'texi2html',
	    '/usr/bin/wx-config' => 'libwxGTK-devel',
	    'ixp' => 'libixp-devel',
	    'net' => 'libnet2-devel',
	    'libnet.h' => 'libnet2-devel',
	    'netlink' => 'libnetlink-devel',
	    'libpng' => 'libpng-devel',
	    'png' => 'libpng-devel',
	    'png.h' => 'libpng-devel',
	    'raw1394' => 'libraw1394-devel',
	    'libraw1394/raw1394.h' => 'libraw1394-devel',
	    'glut' => 'libfreeglut-devel',
	    'GL/glut.h' => 'libfreeglut-devel',
	    'xercesc/util/XercesDefs.hpp' => 'libxerces-c-devel',
	    'xercesc/util/PlatformUtils.hpp' => 'libxerces-c-devel',
	    'xercesc/dom/DOM.hpp' => 'libxerces-c-devel',
	    'xerces-c' => 'libxerces-c-devel',
	    'cpufreq.h' => 'libcpufreq-devel',
	    'db-4.7' => 'libdb4.8-devel',
	    'db-4.8' => 'libdb4.8-devel',
	    'db4/db.h' => 'libdb4.8-devel',
	    'db_185.h' => 'libdb4.8-devel',
	    'db' => 'libdb4.8-devel',
	    'db_cxx' => 'libdb4.8_cxx-devel',
	    'db.h' => 'libdb4.8-devel',
	    'Xm/Xm.h' => 'libopenmotif-devel',
	    'Xm' => 'libopenmotif-devel', # lib
	    'ltdl.h' => 'libltdl-devel', #libltdl7-devel
};

sub get_source_analyzer_hack_opts {
    return -select_multiple_dependency => $select_multiple_dependency_db;
}

sub get_ignore_buildreq_hack_opts {
    return -ignore_buildreq => {map {$_=>1} qw/glibc-devel/};
}

1;
