package RPM::Source::Tools::ShellGlob;

use Exporter 'import';
our @EXPORT_OK = qw(glob2pat specglob2pat);  # symbols to export on request

sub glob2pat {
    my $globstr = shift;
    my %patmap = (
	'*' => '.*',
	'?' => '.',
	'[' => '[',
	']' => ']',
	'{' => '(?:',
	'}' => ')',
	',' => '|',
	);
    $globstr =~ s{(.)} { $patmap{$1} || "\Q$1" }ge;
    return '^' . $globstr . '$';
}

# special version for macros-enriched %files
# do not map {,} as they are part of macros
# and do not append ^...$
sub spec_glob2pat {
    my $globstr = shift;
    my %patmap = (
	'*' => '.*',
	'?' => '.',
	'[' => '[',
	']' => ']',
#	'{' => '(?:',
#	'}' => ')',
	',' => '|',
	);
    $globstr =~ s{(.)} { $patmap{$1} || "\Q$1" }ge;
    return $globstr;
}

1;
