package RPM::Source::Tools::SourceFile;

use Carp;
use strict;
use warnings;
use File::Basename;

use RPM::Source::Tools::SourceBundle;
our @ISA=qw/RPM::Source::Tools::SourceBundle/;

sub new {
    my $class = shift;
    my $self=$class->SUPER::new(@_);
    my $file = $self->{-file};
    Carp::croak "SourceFile: not a $file:\n" if -d $file;
    bless $self, $class;
    return $self;
}

sub extract {
    my ($self, $list)=@_;
    return dirname($self->{-file});
}

sub filelist_cmd {
    my ($self,$file)=@_;
    return "ls '$file'";
}

sub filelist {
    my ($self)=@_;
    return [basename($self->{-file})];
}

1;
