package RPM::Source::Transformation::CheckIfChangedPlayer;

use strict;
use warnings;
use Carp;

use RPM::Source::Transformation::Component;
use RPM::Source::Transformation::Factory;
our @ISA=qw/RPM::Source::Transformation::Component/;

#no need - no methods present
#push @RPM::Source::TransformContainer::SUPPORT_CLASSES, __PACKAGE__;
$RPM::Source::TransformContainer::PLAYER=__PACKAGE__;

our $verbose=0;

sub apply_collection {
    my (undef,$spec,$parent,$opt,$resourceobj,$actions)=@_;

    my $before=$spec->get_spec();
    my @transformations=$actions->get;
    my $raise_release=pop @transformations;
    die "Oops! internal: not a raise release $raise_release->{-name}" if $raise_release->{-name} ne 'raise release';

    foreach my $transformation ($actions->get) {
	my $exit_code=$transformation->apply($spec,$parent,$opt,$resourceobj);
	if ($exit_code == RPM::Source::Transformation::Factory::TRANSFORMATION_FAILURE) {
	    return RPM::Source::Transformation::Factory::TRANSFORMATION_FAILURE;
	} elsif (not defined $exit_code or $exit_code != RPM::Source::Transformation::Factory::TRANSFORMATION_OK) {
	    warn "transformation $transformation->{-name} returned invalid exit code\n";
	}
    }

    if ($before ne $spec->get_spec()) {
	$raise_release->apply($spec,$parent,$opt,$resourceobj);
	return RPM::Source::Transformation::Factory::TRANSFORMATION_OK;
    }
    return RPM::Source::Transformation::Factory::TRANSFORMATION_FAILURE;
}

1;
