package RPM::Source::Transformation::DefaultPlayer;

use strict;
use warnings;
use Carp;

use RPM::Source::Transformation::Component;
use RPM::Source::Transformation::Factory;
our @ISA=qw/RPM::Source::Transformation::Component/;

push @RPM::Source::TransformContainer::SUPPORT_CLASSES, __PACKAGE__;
$RPM::Source::TransformContainer::PLAYER=__PACKAGE__;

our $verbose=0;

sub apply_collection {
    my (undef,$spec,$parent,$opt,$resourceobj,$actions)=@_;
    print STDERR "DefaultPlayer: entering apply_collection.\n" if $verbose;
    foreach my $transformation ($actions->get) {
	print STDERR 'DefaultPlayer: applying '.$transformation->{-name}."...\n" if $verbose;
	my $exit_code=$transformation->apply($spec,$parent,$opt,$resourceobj);
	if ($exit_code == RPM::Source::Transformation::Factory::TRANSFORMATION_FAILURE) {
	    print STDERR 'DefaultPlayer: '.$transformation->{-name}.": returned TRANSFORMATION_FAILURE\n" if $verbose;
	    return RPM::Source::Transformation::Factory::TRANSFORMATION_FAILURE;
	} elsif (not defined $exit_code or $exit_code != RPM::Source::Transformation::Factory::TRANSFORMATION_OK) {
	    warn "transformation '$transformation->{-name}' returned invalid exit code\n";
	}
    }
    print STDERR "DefaultPlayer: leaving apply_collection.\n" if $verbose;
    return RPM::Source::Transformation::Factory::TRANSFORMATION_OK;
}

1;
