package RPM::Source::Transformation::Factory;

use strict;
use warnings;

use RPM::Source::Transformation::Component;
use RPM::Source::Transformation::OptHandlerWrapper;

our $VERSION=0.001;
our @ISA=qw(RPM::Source::Transformation::Component);

use Exporter 'import';
our @EXPORT = qw(TRANSFORMATION_FAILURE TRANSFORMATION_OK
PRIORITY_AT_BEGIN
PRIORITY_POST_BEGIN
PRIORITY_PREHOOKS
PRIORITY_PRECONVERT
PRIORITY_CONVERT
PRIORITY_POSTCONVERT
PRIORITY_HOOKS
PRIORITY_POSTHOOKS
PRIORITY_COMMANDLINE
PRIORITY_DEFAULT
PRIORITY_PRERELEASE
PRIORITY_AT_END
);

use constant {
	TRANSFORMATION_FAILURE	=> 101,
	TRANSFORMATION_OK	=> 0,

	PRIORITY_AT_BEGIN	=> 90,
	PRIORITY_POST_BEGIN	=> 80,
	PRIORITY_PREHOOKS	=> 70,
	PRIORITY_PRECONVERT	=> 60,
	PRIORITY_CONVERT	=> 50,
	PRIORITY_POSTCONVERT	=> 40,
	PRIORITY_HOOKS		=> 30,
	PRIORITY_POSTHOOKS	=> 20,
	PRIORITY_COMMANDLINE	=> 10,
	PRIORITY_DEFAULT	=> 0,
	PRIORITY_PRERELEASE	=> -10,
	PRIORITY_AT_END		=> -20,
};

sub init_factory {}
sub transformations {
    return;
}

1;
