package RPM::Source::Transformation::Factory::Buildreq;

use strict;
use warnings;
use Carp;

use RPM::Source::Transformation::Factory;
use RPM::Source::Transformation::Resource::Buildreq;

our @ISA=qw/RPM::Source::Transformation::Factory/;

push @RPM::Source::TransformContainer::FACTORY_CLASSES, __PACKAGE__;

# $verbose=0;

sub transformations {
    return RPM::Source::Transformation::OptHandlerWrapper->new(
	-priority => PRIORITY_PRERELEASE,
	-name => 'add_buildreq',
	-opt_handler_sub=>\&opt_handler);
}

sub opt_handler {
    my (undef,$spec,$parent,$opt,$resourceobj)=@_;
    my $buildreq=$resourceobj->{'__buildreq'};
    if ($buildreq) {
	$spec->main_section->unshift_body($buildreq->get_spec_entry($spec));
	delete $resourceobj->{'__buildreq'};
    }
    return RPM::Source::Transformation::Factory::TRANSFORMATION_OK;
}

1;
