package RPM::Source::Transformation::Factory::Datapath;

use strict;
use warnings;

use RPM::Source::Transform;
use RPM::Source::Transformation::Factory;
our @ISA=qw/RPM::Source::Transformation::Factory/;

push @RPM::Source::TransformContainer::FACTORY_CLASSES, __PACKAGE__;

sub transformations {
    return 
	RPM::Source::Transformation::OptHandlerWrapper->new(
	    -priority => PRIORITY_AT_BEGIN,
	    # used in CheckIfChangedPlayer
	    -name => 'init copy path',
	    -opt_handler_sub=>\&opt_handler_init_copypath_AT_BEGIN);
}

sub opt_handler_init_copypath_AT_BEGIN {
    my (undef,$spec,$parent,$opt)=@_;
    ## TODO: private access!!!
    $spec->{-copypath}=[@RPM::Source::Transformation::Resource::Datapath::patchdir],
    return RPM::Source::Transformation::Factory::TRANSFORMATION_OK;
}

1;
