package RPM::Source::Transformation::OptHandlerWrapper;

use strict;
use warnings;
use Carp;

sub new {
    my $class = shift;
    my $self = {
	-priority => 0,
	@_
    };
    die "new: -opt_handler_sub is required" unless $self->{-opt_handler_sub};
    bless $self, $class;
    return $self;
}

sub apply {
    my ($self,$spec,$parent,$opt,$resourceobj)=@_;
    die "$spec is undefined" unless $spec;
    my $handler=$self->{-opt_handler_sub};
    my $exit_code=&$handler($self,$spec,$parent,$opt,$resourceobj);
    print STDERR "apply: transformation '$self->{-name}' failed\n" if $exit_code;
    return $exit_code;
}

1;
