package RPM::Source::Transformation::ParentOptions;

use strict;
use warnings;

use RPM::Source::Tools::File2RPMEditor;
use RPM::Source::Transformation::Component;
our @ISA=qw/RPM::Source::Transformation::Component/;

push @RPM::Source::TransformContainer::SUPPORT_CLASSES, __PACKAGE__;
$RPM::Source::TransformContainer::ParentProvider=__PACKAGE__;

our $verbose=0;
our @PARENTS;
our $opt_sourcedir;

sub longopt_usage {
    print "  Parent package input options:
	--parent[-rpm] /path/to/parent/src.rpm
	--parent[-spec] /path/to/parent/spec
	  Supplying parent spec/srpm is optional. If parent spec is supplied,
	parent changelog, Serial/Epoch and possibly Packager tag will be merged.
	--parent-sourcedir /path/to/parent/SOURCEDIR (optional)
	  parent-sourcedir option can be used together with --parent-spec
	to provide a location for parent source files, if required.
";
}

our @LONGOPT=(
    'parent=s'	=> sub {push @PARENTS, &RPM::Source::Tools::File2RPMEditor::file2rpmeditoropts($_[1], $opt_sourcedir) },
    'parent-spec=s' => sub { push @PARENTS, [ SPECFILE => $_[1]]},
    'parent-rpm=s' => sub { push @PARENTS, [ SOURCERPM => $_[1]]},
    'parent-sourcedir=s' => \$opt_sourcedir,
);

sub get {
    my ($self,$extopt)=@_;
    my $parentargs=shift @PARENTS;
    # $parentargs->[0]=SPECFILE, $parentargs->[1] = undef is an encoding for none
    $parentargs=undef unless $parentargs and $parentargs->[0];
    return $parentargs;
}

1;
