package RPM::Source::Transformation::SRPMSpecInputHandler;

use strict;
use warnings;

use RPM::Source::Tools::File2RPMEditor;
use RPM::Source::Transformation::Component;
our @ISA=qw/RPM::Source::Transformation::Component/;

push @RPM::Source::TransformContainer::SUPPORT_CLASSES, __PACKAGE__;
$RPM::Source::TransformContainer::INPUT_HANDLER=__PACKAGE__;

# TODO: make them $opt{}'ed and documented in help
our ($opt_sourcedir);

sub longopt_usage {
    print "  SRPM input options:
	[--rpm] /path/to/src.rpm
	[--spec] /path/to/spec
	--sourcedir <dir> - default SOURCEDIR location for the provided spec file.
";
}

our @LONGOPT=(
    'rpm=s'	=> sub { push @RPM::Source::Transform::INSRC, [ SOURCERPM => $_[1]]},
    'sourcedir=s' => sub {$opt_sourcedir=$_[1]},
    'spec=s'	=> sub {push @RPM::Source::Transform::INSRC, defined $opt_sourcedir ? [SPECFILE => $_[1], SOURCEDIR=> $opt_sourcedir] : [ SPECFILE => $_[1]]}
    );

sub process_args {
    my ($self)=@_;
    map {push @RPM::Source::Transform::INSRC, &RPM::Source::Tools::File2RPMEditor::file2rpmeditoropts($_, $opt_sourcedir)} @ARGV;
}

sub verify_args {
    my ($self)=@_;
    return 1 if @RPM::Source::Transform::INSRC;
    print STDERR "ERROR: please, specify [ --rpm | --spec ] /path/to/file argument.\n";
    return 0;
}

package RPM::Source::Transform;

use strict;
use warnings;

our @INSRC;

sub transform {
    my ($self)=@_;
    while (@INSRC) {
	my $opt_transform=$self->mk_opt();
	# debug opt
	# use Data::Dumper;
	# print Dumper($opt);
	my $spec=$self->get_spec(shift @INSRC);
	my $parent;
	$parent=$self->get_parent($RPM::Source::TransformContainer::ParentProvider->get()) if $RPM::Source::TransformContainer::ParentProvider;
	$self->transform_once($spec,$parent,$opt_transform);
    };
}

1;
